import { Injector } from '@angular/core';
import { filters, services } from 'typescript-angular-utilities';
import __genericSearchFilter = services.genericSearchFilter;
import { CardContainerComponent } from '../cardContainer';
import { IColumn } from '../column';
import * as dataSources from '../dataSources/index';
import * as paging from '../paging/index';
import { IDataSourceBuilder, DataSourceBuilder } from './dataSourceBuilder.service';
import { IFilterBuilder, FilterBuilder } from './filterBuilder.service';
export declare enum CardContainerType {
    old = 0,
    standard = 1,
    selectable = 2,
}
export interface ICardContainerBuilder {
    dataSource: IDataSourceBuilder;
    filters: IFilterBuilder;
    containerData: any;
    cardController: string;
    cardControllerAs: string;
    cardAs: string;
    maxColumnSorts: number;
    disableSelection: {
        (item: any): string;
    };
    useSearch(tokenized?: boolean): __genericSearchFilter.IGenericSearchFilter;
    searchFilter(filter: __genericSearchFilter.IGenericSearchFilter): __genericSearchFilter.IGenericSearchFilter;
    usePaging(): void;
    addColumn<TItemType>(column: IColumn<TItemType>): void;
    useClickableCards(): void;
    usePermanentFooters(): void;
    useSelection(): void;
    renderFilters(): void;
    saveWhenInvalid(): void;
}
export declare class CardContainerBuilder implements ICardContainerBuilder {
    _dataSource: dataSources.IDataSource<any>;
    _filters: filters.IFilter[];
    _paging: boolean;
    _columns: IColumn<any>[];
    _clickableCards: boolean;
    _permanentFooters: boolean;
    _selectableCards: boolean;
    _disableSelection: {
        (item: any): string;
    };
    _searchFilter: __genericSearchFilter.IGenericSearchFilter;
    _pager: paging.IDataPager;
    _renderFilters: boolean;
    _saveWhenInvalid: boolean;
    dataSource: DataSourceBuilder;
    filters: FilterBuilder;
    maxColumnSorts: number;
    containerData: any;
    cardController: string;
    cardControllerAs: string;
    cardAs: string;
    private injector;
    constructor(injector: Injector, dataSourceBuilder: DataSourceBuilder, filterBuilder: FilterBuilder);
    useSearch(tokenized?: boolean): __genericSearchFilter.IGenericSearchFilter;
    searchFilter(filter: __genericSearchFilter.IGenericSearchFilter): __genericSearchFilter.IGenericSearchFilter;
    usePaging(): void;
    addColumn<TItemType>(column: IColumn<TItemType>): void;
    useClickableCards(): void;
    usePermanentFooters(): void;
    useSelection(): void;
    renderFilters(): void;
    saveWhenInvalid(): void;
    disableSelection: {
        (item: any): string;
    };
    setCardContainerProperties(cardContainer: CardContainerComponent<any>): void;
}
