import { services, filters } from 'typescript-angular-utilities';
import __array = services.array;
import __object = services.object;
import __synchronizedRequests = services.synchronizedRequests;
import { IServerSearchFunction, IServerSearchParams } from '../asyncTypes';
import { IAsyncDataSource, AsyncDataSource } from '../asyncDataSource.service';
import { IDataSourceProcessor } from '../dataSourceProcessor.service';
export interface IServerSideDataSource<TDataType> extends IAsyncDataSource<TDataType> {
    filters: filters.ISerializableFilter<any>[];
}
export declare class ServerSideDataSource<TDataType> extends AsyncDataSource<TDataType> {
    private object;
    constructor(getDataSet: IServerSearchFunction<TDataType>, dataSourceProcessor: IDataSourceProcessor, array: __array.IArrayUtility, object: __object.IObjectUtility, synchronizedRequestsFactory: __synchronizedRequests.ISynchronizedRequestsFactory);
    refresh(): void;
    protected getParams(): IServerSearchParams;
    protected resolveReload(result: any): void;
}
